﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System.Linq;

public class test : MonoBehaviour
{
    /// <summary>
    /// Based on: Daniel D'Agostino's Code:
    /// https://bitbucket.org/dandago/experimental/src/bd19cef6fb2e0709d10e10a2ad854fe9d8249066/AStarPathfinding/AStarPathfinding/Program.cs
    /// </summary>

    public GameObject Kind_Start;
    public GameObject Kind_End;
    public GameObject Kind_Block;
    public GameObject Kind_Neutral;

    public int map_max_size = 7;

    bool path_found = false;

    List<Location> bestWayList = new List<Location>(); // Contains the Elements of the best way - What we actually looking for

    RaycastHit hit; // Needed to hit Cubes

    
    void Start()
    {
        StartCoroutine("Algorithmus");
    }

    IEnumerator Algorithmus()
    {
        Debug.Log("A* Pathfinding Project ist starting");

        int[,] karte = new int[map_max_size, map_max_size];

        karte[1, 1] = 1; // Start
        karte[4, 5] = 2; // End
        karte[0, 2] = 99; // Block
        karte[1, 2] = 99; // Block
        karte[2, 2] = 99; // Block
        
        karte[3, 4] = 99; // Block
        karte[4, 3] = 99; // Block
        karte[5, 3] = 99; // Block
        
        // Setzen der Variablen
        Location current = null;
        var start = new Location { X = 1, Y = 2 };// Wird nachher gleich geändert
        var ziel = new Location { X = 4, Y = 5 };// Wird nachher gleich geändert
        
        int g = 0;

        var openList = new List<Location>();
        var closedList = new List<Location>();

        // Karte zeichnen
        for (int x = 0; x < map_max_size; x++)
        {
            for (int y = 0; y < map_max_size; y++)
            {
                if (karte[x, y] == 1)
                {
                    Instantiate(Kind_Start, new Vector3(x, 0, y), Quaternion.identity);
                    start = new Location { X = x, Y = y };// Setze die Start Position
                }
                if (karte[x, y] == 2)
                {
                    Instantiate(Kind_End, new Vector3(x, 0, y), Quaternion.identity);
                    ziel = new Location { X = x, Y = y };// Setze die End Position
                }
                if (karte[x, y] == 99)
                {
                    Instantiate(Kind_Block, new Vector3(x, 0, y), Quaternion.identity);
                }
                if (karte[x, y] == 0)
                    Instantiate(Kind_Neutral, new Vector3(x, 0, y), Quaternion.identity);
            }
        }





        // Algorithmus
        // start by adding the original position to the open list
        openList.Add(start);



        while (openList.Count > 0)
        {   

            /*
            for (int x = 0; x < map_max_size; x++)
            {
                for (int y = 0; y < map_max_size; y++)
                {
                    if (Physics.Raycast(new Vector3(x, 2, y), transform.TransformDirection(Vector3.down), out hit, 100))
                    {
                        Debug.DrawRay(new Vector3(x, 2, y), transform.TransformDirection(Vector3.down) * hit.distance, Color.red, 30);
                        hit.transform.gameObject.GetComponent<Renderer>().material.color = Color.cyan;
                        Debug.Log("Did Hit:" + hit.transform.name, hit.transform.gameObject);
                    }
                }
            }
            */














            // get the square with the lowest F score
            var lowest = openList.Min(l => l.F);
            current = openList.First(l => l.F == lowest);

            // add the current square to the closed list
            closedList.Add(current);


            //Zeigt das aktuell verarbeitete  Game Objekt auf der Karte an
            /*
            if (Physics.Raycast(new Vector3(current.X, 2, current.Y), transform.TransformDirection(Vector3.down), out hit, 100))
            {
                Debug.DrawRay(new Vector3(current.X, 2, current.Y), transform.TransformDirection(Vector3.down) * hit.distance, Color.red, 30);
                hit.transform.gameObject.GetComponent<Renderer>().material.color = Color.yellow;
            }
            yield return new WaitForSeconds(0.01F);
            */
            // remove it from the open list
            openList.Remove(current);



            // Ziel gefunden
            // if we added the destination to the closed list, we've found a path
            if (closedList.FirstOrDefault(l => l.X == ziel.X && l.Y == ziel.Y) != null)
            {
                Debug.Log("<color=green>Ziel gefunden</color>");
                Show_Best_Path();
                path_found = true;
                break;
            }


            /*
            if (current.X == map_max_size || current.Y == map_max_size)
                break;
                */


            if (current.X > 0 && current.Y > 0 && current.X < map_max_size - 1 && current.Y < map_max_size - 1)
            {
                var adjacentSquares = GetWalkableAdjacentSquares(current.X, current.Y, karte);
                g++;



                foreach (var adjacentSquare in adjacentSquares)
                {
                    // if this adjacent square is already in the closed list, ignore it
                    if (closedList.FirstOrDefault(l => l.X == adjacentSquare.X
                            && l.Y == adjacentSquare.Y) != null)
                        continue;

                    // if it's not in the open list...
                    if (openList.FirstOrDefault(l => l.X == adjacentSquare.X
                            && l.Y == adjacentSquare.Y) == null)
                    {
                        // compute its score, set the parent
                        adjacentSquare.G = g;
                        adjacentSquare.H = ComputeHScore(adjacentSquare.X, adjacentSquare.Y, ziel.X, ziel.Y);
                        adjacentSquare.F = adjacentSquare.G + adjacentSquare.H;
                        adjacentSquare.Parent = current;

                        // and add it to the open list
                        openList.Insert(0, adjacentSquare);
                    }
                    else
                    {
                        // test if using the current G score makes the adjacent square's F score
                        // lower, if yes update the parent because it means it's a better path
                        if (g + adjacentSquare.H < adjacentSquare.F)
                        {
                            adjacentSquare.G = g;
                            adjacentSquare.F = adjacentSquare.G + adjacentSquare.H;
                            adjacentSquare.Parent = current;
                        }

                    }
                    
                }



            }
            bestWayList.Clear();








            while (current != null)
            {

                if (Physics.Raycast(new Vector3(current.X, 2, current.Y), transform.TransformDirection(Vector3.down), out hit, 100))
                {
                    Debug.DrawRay(new Vector3(current.X, 2, current.Y), transform.TransformDirection(Vector3.down) * hit.distance, Color.red, 30);
                    hit.transform.gameObject.GetComponent<Renderer>().material.color = Color.green;
                    //Debug.Log("Did Hit:" + hit.transform.name, hit.transform.gameObject);

                    bestWayList.Add(current);
                }
                yield return new WaitForSeconds(0.03F);

                current = current.Parent;

            }



            
        }









        if (path_found == false)
        {
            Debug.Log("<color=red>KEIN Ziel gefunden</color>");
        }




        yield return null;
    }




    void Show_Best_Path()
    {
        foreach(var item in bestWayList)
        {
            if (Physics.Raycast(new Vector3(item.X, 2, item.Y), transform.TransformDirection(Vector3.down), out hit, 100))
            {
                Debug.DrawRay(new Vector3(item.X, 2, item.Y), transform.TransformDirection(Vector3.down) * hit.distance, Color.red, 30);
                hit.transform.gameObject.GetComponent<Renderer>().material.color = Color.black;
            }
        }
    }



    void GetFinalPath(Location a_StartingNode, Location a_EndNode)
    {
        /*
        List<Location> FinalPath = new List<Location>();//List to hold the path sequentially 
        Location CurrentNode = a_EndNode;//Node to store the current node being checked

        Debug.Log("<color=yellow>Am final,isiueren  X:" + CurrentNode.X + "   Y:" + CurrentNode.Y + "</color>");

        while (CurrentNode != a_StartingNode)//While loop to work through each node going through the parents to the beginning of the path
        {
            Debug.Log("<color=cyan>Am final,isiueren  X:" + CurrentNode.X + "   Y:" + CurrentNode.Y + "</color>");
            FinalPath.Add(CurrentNode);//Add that node to the final path
            CurrentNode = CurrentNode.Parent;//Move onto its parent node
        }

        FinalPath.Reverse();//Reverse the path to get the correct order

        //GridReference.FinalPath = FinalPath;//Set the final path
        Debug.Log("<color=cyan>FInalisierter Pfade gemacht</color>");
        */
    }









    static List<Location> GetWalkableAdjacentSquares(int x, int y, int[,] karte)
    {
        var proposedLocations = new List<Location>()
        {
            new Location { X = x, Y = y - 1 },
            new Location { X = x, Y = y + 1 },
            new Location { X = x - 1, Y = y },
            new Location { X = x + 1, Y = y },
        };
        return proposedLocations.Where(l => karte[l.X, l.Y] == 0 || karte[l.X, l.Y] == 2).ToList();
    }

    //Heuristische Distanz zwischen aktuellem und end Punkt
    static int ComputeHScore(int x, int y, int targetX, int targetY)
    {
        return Mathf.Abs(targetX - x) + Mathf.Abs(targetY - y);
    }







    class Location
    {
        public int X;
        public int Y;
        public int F;
        public int G;
        public int H;
        public Location Parent;
    }

}

